<?php
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

/*
** DGS Search
** db.php written by James Sella and Max Spaulding
** Copyright (c) 2000-2001 Digital Genesis Software, LLC. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
// last changed 21/05/2005 to search Site@school modules  Fred Stuurman (fc.stuurman@gmail.com)
#$Id: db.php,v 1.1 2006/10/03 08:54:49 fstuurman Exp $
*/

function db($retVal, $q, $r, $o, $s, $timer)
{
	global $config, $database;

	$matchCount = count($retVal);
	$maxSearchTime = 25;


	if ($s > 0 && $matchCount >= $r + $o) //If we know the size already and have enough matches, return.
		return $retVal;

	$tm = getTime();

	reset($database);

	while (list (, $db1) = each($database))
	{
		if (getTime() - $timer > $maxSearchTime)
		{
			break;
		}
		$result = searchMySQL($db1, $q, $r, $o, $s, $matchCount);
		reset($result);

		while (list (, $match) = each($result))
		{
			/* Do URL substitutions where needed. */
			$matchCount++;

			if ($matchCount < $o || $matchCount > $r + $o) //Only build the desc if we need them.
			{
				$retVal[] = array (
					0
				); //Place holder, since this is outside of the displayed results.
			}
			else
			{
				$link = $db1['link'];
				$url = $db1['url'];
				$descArray = $db1['desc'];
				$descWidth = 140;
				$rfields = $db1['returnField'];
				$i = 0;
				if (!is_array($descArray))
					$descArray = array ();
				reset($rfields);
				while (list (, $field) = each($rfields))
				{
					$matchField = trim($match[$field]);
					$var = sprintf('@%d@', $i);
					$link = str_replace($var, $matchField, $link);
					$url = str_replace($var, $matchField, $url);
					reset($descArray);
					while (list ($idx, $desc) = each($descArray))
					{
						$descArray[$idx] = str_replace($var, $matchField, $desc);
					}
					$i++;
				}

				if ($descWidth > 0)
				{
					reset($descArray);

					while (list ($idx, $desc) = each($descArray))
					{
						$desc = processWindow(addslashes($desc), $descWidth, 1, $q, $matchCount);
						
						//if(IsSet($desc[0]))
						//{
						$descArray[$idx] = $desc[0]; /* processWindow() sets the index to 0 for the first item. */
						//}
					}
				}

				$retVal[] = array (
					'link' => $link,
					'url' => $url,
					'description' => $descArray
				);
			}

			if ($s > 0 && $matchCount > $r + $o) //If we know the size already and have enough matches, break.
				break;
		}
	}

	return $retVal;
}

function searchMySQL($db1, $q, $r, $o, $s, $c)
{
	global $config, $db;

	$tables = $db1['table'];
	$rfields = $db1['returnField'];
	$sfields = $db1['searchField'];
	$select = $db1['select'];
	$retVal = array ();
	// by JG begin
	// could be extended for other languages
	$q = str_replace('&auml;', '', $q);
	$q = str_replace('&Auml;', 'A', $q); // strtolower() does not work for noASCII-Charakters
	$q = str_replace('&ouml;', '', $q);
	$q = str_replace('&Ouml;', '', $q);
	$q = str_replace('&uuml;', '', $q);
	$q = str_replace('&Uuml;', '', $q);
	$q = str_replace('&szlig;', '', $q);
	//printf("----- LIKE statement $q: ------> %s <br> \n",$q);
	// by JG end
	$keywords_array = explode(" ", $q);

	$query = 'SELECT ';
	$orderBy = ' ORDER BY ';
	$offset = $c - $o;

	$i = 0;
	reset($rfields);
	while (list (, $entry) = each($rfields))
	{
		$query .= $entry;
		$orderBy .= $entry;
		$i++;
		if ($i < count($rfields))
		{
			$query .= ', ';
			$orderBy .= ', ';
		}
	}

	$query .= ' FROM ';

	$i = 0;
	reset($tables);
	while (list (, $entry) = each($tables))
	{
		$i++;
		$query .= $entry;
		if ($i < count($tables))
			$query .= ', ';
	}

	$query .= ' WHERE (';

	$i = 0;
	reset($sfields);

	while (list (, $entry) = each($sfields))
	{
		$i++;

		foreach ($keywords_array as $value)
		{
			$query .= $entry . ' LIKE \'%' .  mysqli_real_escape_string($db, $value) . '%\' AND ';
		}
		$query = substr($query, 0, -4); //strip last AND
		if ($i < count($sfields))
			$query .= ' OR ';
	}
	$query .= ")"; //if extra select exists for a module add it.

	if ($select[0] != "")
	{
		$query .= " " . $select . " ";
	}
	$query .= $orderBy;
	
	$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db1).'"<br>Query : "' . $query . '".',E_USER_WARNING); 

	$width = count($rfields);
	$row = 0;
	while ($line = mysqli_fetch_row($result))
	{
		for ($i = 0; $i < $width; $i++)
		{
			$retVal[$row][$rfields[$i]] = $line[$i];
		}
		$row++;
	}
	return $retVal;

}
?>